<?php

declare(strict_types=1);

namespace Dedi\SyliusMailAdminPlugin\EventListener\MailAdmin;

use Dedi\SyliusMailAdminPlugin\Event\DediMailAdminEvent;
use Sylius\Bundle\UserBundle\Mailer\Emails;
use Sylius\Component\User\Model\UserInterface;
use Symfony\Bundle\FrameworkBundle\Routing\Router;
use Symfony\Component\Routing\RouterInterface;

class VerificationTokenPreRendererListener
{
    private RouterInterface $router;

    public function __construct(RouterInterface $router)
    {
        $this->router = $router;
    }

    public function __invoke(DediMailAdminEvent $event): DediMailAdminEvent
    {
        if (Emails::EMAIL_VERIFICATION_TOKEN !== $event->getEmail()->getCode()) {
            return $event;
        }

        $data = $event->getData();
        /** @var UserInterface $user */
        $user = $data['user'];

        $data['verificationUrl'] = $this->router->generate('sylius_shop_user_verification', [
            'token' => $user->getEmailVerificationToken(),
        ], Router::ABSOLUTE_URL);

        $event->setData($data);

        return $event;
    }
}
